class Admin::ModuleAppsController < OrbitAdminController
  before_action :check_auth 
  include AdminHelper

  def index
  	@module_app = ModuleApp.find params[:module_app_id]
    @managers = Authorization.module_authorized_users(@module_app)
  end

  def check_auth
  	unless (is_admin? || is_manager?) 
  	  flash[:error] = "unauthorized access"
  	  if request.env["HTTP_REFERER"]
        redirect_to :back
      else
        render 'public/403.html', :status => 403, :layout => false
      end
      false
    end
  end

  def setting
  	@sys_users = User.not_admins
  	@module_app = ModuleApp.find(params[:module_app_id])
  end
end
