module Admin::GroupsHelper
	def remote_file_exists?(url)
	    url = URI.parse(url)
	    Net::HTTP.start(url.host, url.port) do |http|
	      return http.head(url.request_uri)['Content-Type'].start_with? 'image'
	    end
	end

	def parse_for_images(content)
  		urls = URI.extract(content)
    	images = []
      	urls.each do |url|
        	images << url if !url.nil? && remote_file_exists?(url) 
      	end if !urls.empty?
      	
      	image_content = "<br />"
      	images.each do |img|
      		content = content.sub(img,"")
      		image_content = image_content + "<img src='#{img}' style='width:auto;' /><br />"
      	end if !images.empty?
      	return [content, image_content]
	end

 def is_user_group_admin?
    return (@access_right_level == "admin" ? true : false)
  end

  def user_can_write?
    return (@access_right_level == "admin" || @access_right_level == "write" ? true : false)
  end

  def user_can_read?
    return (@access_right_level == "admin" || @access_right_level == "write" || @access_right_level == "read" ? true : false)
  end
end